import copy
from typing import Any
from typing import Dict

from deepdiff import DeepDiff

# TODO: Resource names, e.g. queue_name, must be supplied separately as an attribute.
#  Should the idem name be used for these names, instead?
# TODO: The resource_id could be very long and ugly since it is generated by AWS,
#  perhaps map it to a shorter unique ID
# TODO: jsonschemaforhumans does not indicate which properties are read-only in the generated docs


async def present(
    hub,
    ctx,
    name: str,
    resource_type: str,
    resource_id: str = None,
    **attributes: Dict[str, Any],
) -> Dict[str, Any]:

    result = dict(comment=(), old_state={}, new_state={}, name=name, result=True)

    resource_info_ret = await hub.tool.awscc.cloudcontrol.api.get_resource_info(
        ctx, resource_type
    )
    if not resource_info_ret["result"]:
        result["result"] = False
        result["comment"] = resource_info_ret["comment"]
        return result

    attributes = hub.tool.awscc.cloudcontrol.api.convert_attributes_names(
        attributes, False
    )
    aws_type_name = resource_info_ret["aws_type_name"]
    read_only_attributes = set(resource_info_ret["read_only_attributes"])
    validation_result = hub.tool.awscc.cloudcontrol.api.validate_attributes(
        attributes, resource_info_ret["validation_schema"], read_only_attributes
    )
    if not validation_result["result"]:
        result["result"] = False
        result["comment"] = validation_result["comment"]
        return result

    # Check if resource exists
    if resource_id:
        old_state_ret = await hub.tool.awscc.cloudcontrol.api.get_resource(
            ctx, aws_type_name, resource_id, read_only_attributes
        )
        if old_state_ret["result"]:
            result["old_state"] = old_state_ret["state"]
        else:
            result["result"] = False
            result["comment"] = old_state_ret["comment"]
            return result

    operation_result = dict(result=False, comment=(), new_state={})
    if result["old_state"]:

        old_attributes = copy.deepcopy(result["old_state"])
        old_attributes.pop("resource_id")

        no_changes = True
        is_create_only_attribute_changed = False
        create_only_attributes = set(resource_info_ret["create_only_attributes"])
        for attribute_name, new_attribute_value in attributes.items():
            old_attribute_value = old_attributes.get(attribute_name)
            if DeepDiff(
                new_attribute_value,
                old_attribute_value,
                ignore_order=True,
                report_repetition=True,
            ):
                no_changes = False
                if attribute_name in create_only_attributes and old_attribute_value:
                    is_create_only_attribute_changed = True
                    break

        if no_changes:
            # Resource already exists or there are no updates to properties
            result["comment"] += (f"The resource '{name}' already exists",)
            result["new_state"] = result["old_state"]
            return result

        if (
            resource_info_ret["is_resource_mutable"]
            and not is_create_only_attribute_changed
        ):
            if ctx.get("test"):
                operation_result[
                    "comment"
                ] += hub.tool.awscc.comment_utils.would_update_comment(
                    aws_type_name, name
                )
                operation_result["new_state"] = attributes
                operation_result["new_state"]["resource_id"] = resource_id
            else:
                # Update the resource
                operation_result = await hub.tool.awscc.cloudcontrol.api.update_resource(
                    ctx,
                    name,
                    aws_type_name,
                    resource_id,
                    old_attributes,
                    attributes,
                    read_only_attributes,
                )
        else:
            if ctx.get("test"):
                operation_result[
                    "comment"
                ] += hub.tool.awscc.comment_utils.would_replace_comment(
                    aws_type_name, name
                )
                operation_result["new_state"] = attributes
                operation_result["new_state"]["resource_id"] = resource_id
            else:
                # Replace the resource
                operation_result = await hub.tool.awscc.cloudcontrol.api.replace_resource(
                    ctx,
                    name,
                    aws_type_name,
                    resource_id,
                    attributes,
                    read_only_attributes,
                )
    else:
        if ctx.get("test"):
            operation_result[
                "comment"
            ] += hub.tool.awscc.comment_utils.would_create_comment(aws_type_name, name)
            operation_result["new_state"] = attributes
        else:
            # Create the resource
            operation_result = await hub.tool.awscc.cloudcontrol.api.create_resource(
                ctx, name, aws_type_name, attributes, read_only_attributes
            )

    result["new_state"] = operation_result["new_state"]
    result["result"] = operation_result["result"]
    result["comment"] += operation_result["comment"]

    return result


async def absent(
    hub, ctx, name: str, resource_type: str, resource_id: str = None
) -> Dict[str, Any]:

    result = dict(comment=(), old_state=None, new_state=None, name=name, result=True)

    resource_info_ret = await hub.tool.awscc.cloudcontrol.api.get_resource_info(
        ctx, resource_type
    )
    if not resource_info_ret["result"]:
        result["result"] = False
        result["comment"] = resource_info_ret["comment"]
        return result

    aws_type_name = resource_info_ret["aws_type_name"]
    read_only_attributes = resource_info_ret["read_only_attributes"]
    if resource_id:
        old_state_ret = await hub.tool.awscc.cloudcontrol.api.get_resource(
            ctx, aws_type_name, resource_id, read_only_attributes
        )
        if old_state_ret["result"]:
            result["old_state"] = old_state_ret["state"]
        else:
            result["result"] = False
            result["comment"] = old_state_ret["comment"]
            return result

    if result["old_state"]:
        if ctx.get("test"):
            result["comment"] += hub.tool.awscc.comment_utils.would_delete_comment(
                aws_type_name, name
            )
        else:
            operation_result = await hub.tool.awscc.cloudcontrol.api.delete_resource(
                ctx, name, aws_type_name, resource_id, read_only_attributes
            )
            result["result"] = operation_result["result"]
            result["comment"] += operation_result["comment"]
    else:
        result["comment"] = hub.tool.awscc.comment_utils.already_absent_comment(
            aws_type_name, name
        )

    return result


async def describe(
    hub, ctx, resource_type: str, **resource_attributes: Dict[str, Any]
) -> Dict[str, Dict[str, Any]]:
    # resource_type = "sqs_queue"
    # resource_attributes = {}
    resource_info_ret = await hub.tool.awscc.cloudcontrol.api.get_resource_info(
        ctx, resource_type
    )
    if not resource_info_ret["result"]:
        hub.log.debug(resource_info_ret["comment"])
        return {}

    aws_type_name = resource_info_ret["aws_type_name"]

    resources_ids_ret = await hub.tool.awscc.cloudcontrol.api.list_resources_ids(
        ctx, aws_type_name, resource_attributes
    )
    if not resources_ids_ret["result"]:
        hub.log.debug(resources_ids_ret["comment"])
        return {}

    result = {}
    for resource_id in resources_ids_ret["resources_ids"]:
        resource_state_ret = await hub.tool.awscc.cloudcontrol.api.get_resource(
            ctx, aws_type_name, resource_id, resource_info_ret["read_only_attributes"]
        )
        if resource_state_ret["result"]:
            resource_state_ret["state"].pop("resource_id")
            attributes_list = [
                {attribute_name: attribute_value}
                for attribute_name, attribute_value in resource_state_ret[
                    "state"
                ].items()
            ]
            result[resource_id] = {f"{resource_type}.present": attributes_list}
        else:
            hub.log.debug(resource_state_ret["comment"])

    return result
